/*  File:     serial.c
    Purpose:  To provide UART functionality for PIC uC
*/

#include "Includes.h"

void InitUART(void)
{
	//Comm Setup
	#define BAUDRATE 9600  //bps

	TRISC6 = 0;   //TX Pin
	TRISC7 = 1;   //RX Pin
	
	SPBRG = ((_XTAL_FREQ/BAUDRATE)/64) - 1;
	BRGH  = 0;                   	//low baudrate
	SYNC  = 0;						//asynchronous
	SPEN  = 1;						//enable serial port pins
	CREN  = 1;						//enable reception
	SREN  = 0;						//no effect
	TXIE  = 0;						//disable tx interrupts
	RCIE  = 1;						//enable rx interrupts
	TX9   = 0;						//8-bit transmission
	RX9   = 0;						//8-bit reception
	TXEN  = 0;						//reset transmitter
	TXEN  = 1;						//enable the transmitter
}


void SendByteSerially(unsigned char Byte)  //Writes a character to the serial port
{
	while(!TXIF);  //wait for previous transmission to finish
	TXREG = Byte;
}

unsigned char ReceiveByteSerially(void)   //Gets a character from the serial port
{
	if(OERR) //if over run error, then reset the receiver
	{
		CREN = 0;
		CREN = 1;
	}
	if(RCIF)
	return RCREG;
return '\0';
//	while(!RCIF);  //wait for transmission to receive
	

}

void SendStringSerially(const unsigned char* st)
{
	while(*st)
		SendByteSerially(*st++);
}